# ezrep 
Easy menu-driven reporting for TF2Center lobbies. Type __!r__ to start

_version 1.01_ by [naknak](http://steamcommunity.com/id/_naknak_/)

### Description

This plugin corrects common mistakes and omissions when reporting players in a TF2Center lobby.  Unambiguous reports are corrected and sent right away.
Incomplete reports generate menus to extract the missing information.

The plugin can deactivate when there is no lobby running on the server (as indicated by match-start and match-end announcements from TF2Center) and also lets you tie actions and announcements to these events.

### Use

![!r to see two menus](images/example0.png) ![rep a team to see a class menu](images/example1.png) ![should abbreviation be such a long word?](images/example2.png)

You can make reports like you always have, and let the plugin correct typos for you.  You can also abbreviate reports. Any unambiguous abbreviation will work!  Ambiguous abbreviations will _also_ work (with menus)!

- `!r r m` reports the red medic.  `!r b sn` or `!r b snip` or `!re bl snipe` all report the blu sniper.
- `!r r r` reports the red roamer in a 6v6 game.  In Highlander, where there is no "r" class, you get a menu to pick which red class you meant.
- `!r b p` reports the pocket in 6v6, or the pyro otherwise.
- `!r demo` (or just `!r d`) will open a menu to ask which team you meant.  `!r blu` (or `!r b`) will open a menu to ask which class you meant.
- `!r` will open two menus, one to pick a team and one to pick a class.

The plugin switches to 6v6 reporting style (`!rep blu roamer`) automatically, using either the lobby announcement from TF2Center or the count of connected players.  This assumption may occasionally be wrong; you can always specify the other style through the team menu.

### Installation

Just drop [ezrep.smx](http://naknak.tf/code/ezrep/ezrep.smx) into your plugins folder (typically `/tf/addons/sourcemod/plugins`). Activate it with `rcon sm plugins load ezrep` (or just restart your server).  The only prerequite is the SourceMod core.

### Configuration

No configuration is necessary.  These cvars are available:

- `ezrep_always` if 1, rep correction and menus are always active.  If 0, correction is (de)activated by lobby start/end messages from TF2Center.   Default 0.

- `ezrep_launch_announce` a message sent to all connected players soon after the lobby launches.  The default is a help message for ezrep.
- `ezrep_launch_announce_delay` the time, in seconds, between launch and announcement.  If too small, no one will be connected yet to see it!  Default is 120 (2 minutes). 0 disables the announcement.  You can use color codes in this text:

![^1 for normal, ^3 for light green, ^4 for lime green, ^5 for olive and ^6 for black](images/text_colors.png)

- `ezrep_launch_action` a server command to run on lobby launch.  Default is `mp_tournament_restart`. 
- `ezrep_launch_action_delay` the time, in seconds, between lobby launch and invocation of `ezrep_launch_action`.  Default 10. 0 disables.

- `ezrep_close_announce` a message to broadcast upon completion (or leader abortion) of the lobby.  
- `ezrep_close_announce_delay` the time, in seconds, between lobby close and announcement.  Unlike `ezrep_launch_announce_delay`, this value should be small if you want anyone to see it. It should also be large enough to allow the scoreboard to close.  Default is 10 seconds. 0 disables the announcement.

- `ezrep_close_action` a server command to run on lobby close.  Default is `mp_tournament_restart`.  Other useful possibilities include:
  * `exec ugc_off`
  * `kickall`
  * `quit`
  * `tv_off`
  * all of the above, using a .cfg file of your own and `exec`
- `ezrep_close_action_delay` the time, in seconds, between lobby close and invocation of  `ezrep_close_action`.  Default 120. 0 disables.



### Limitations

It is not possible to include player names in the menus (accurately).  TF2Center limits access to the lobby webpage when it launches, so this information is just not available to anyone except the players themselves.  Sorry.

For the same reason, things like `!rep myself` or `!rep that_guy_who_just_disconnected` can't work.  

Payload maps are a common source of confusion: the players change teams halfway through while their report-names ("red scout") remain the same and refer to the team opposite the one they're actually on.  This is such a mess that the plugin does not try to fix it at all.  In the second half of a payload or A/D map, RED means BLU and BLU means RED, with or without the plugin installed.

### Changelog
#### version 1.02 2014-05-27
- more cvars: debug, gametype, inlobby
- 1/3 reduction in memory footprint (now 40KB) through string size adjustment
- bugfix "!rep red scout" was considered valid in 6v6 (isn't): remove IncrTokens and giant Tokenizer regex, use piecewise tokenization that can consume multiple words, repurpose the UNDEF regex to consume a token on match
- setting the action or announce cvars to empty will skip that thing instead of acting on an empty string
- doco update: images and stuff

#### version 1.02 2014-05-26
- added color codes to announce messages, e.g. "^1 this is normal ^3 this is green"
- fixed some off-by-one errors in string length
- renamed cvars ("sm" prefix is for sourcemod core)

#### version 1.0 2014-05-25
initial release

